import itertools
import os
import re
import sys

def fix_line(line, index):
    mark, rev = re.match(r'^:(\d+) (.*)$', line).groups()
    new_mark = int(mark) << 2 | index
    return ':{} {}\n'.format(new_mark, rev)

directory = sys.argv[1]
output = os.path.join(
    os.path.dirname(__file__),
    'data', 'marks.bzr')
with open(output, 'wb') as out:
    for index, project in enumerate(['server', 'web', 'addons']):
        with open(os.path.join(os.path.abspath(directory),
                               project + '.bzr.marks'),
                    'rb') as proj_marks:
            out.writelines(
                itertools.imap(
                    fix_line,
                    proj_marks,
                    itertools.repeat(index)))
